package me.limeglass.skungee.spigot.elements.expressions;

import java.util.Set;

import org.bukkit.event.Event;

import ch.njol.skript.doc.Description;
import ch.njol.skript.doc.Name;
import me.limeglass.skungee.objects.packets.SkungeePacket;
import me.limeglass.skungee.objects.packets.SkungeePacketType;
import me.limeglass.skungee.spigot.lang.SkungeePropertyExpression;
import me.limeglass.skungee.spigot.utils.Utils;
import me.limeglass.skungee.spigot.utils.annotations.Properties;
import me.limeglass.skungee.spigot.utils.annotations.PropertiesAddition;

@Name("Bungeecord player play time")
@Description("Returns the play time(s) of the defined Bungeecord player(s).")
@Properties({"strings/players", "bungee[[ ]cord] play[ ]time [(of|for|on) servers %strings-%]", "{1}[(all [[of] the]|the)]"})
@PropertiesAddition("[(player|uuid)[s]]")
public class ExprBungeePlayerPlayTime extends SkungeePropertyExpression<Object, Number> {

	@Override
	protected Number[] get(Event event, Object[] skungeePlayers) {
		if (isNull(event))
			return null;
		@SuppressWarnings("unchecked")
		Set<Number> times = (Set<Number>) sockets.send(new SkungeePacket(true, SkungeePacketType.PLAYTIME, expressions.getAll(event, String.class), Utils.toSkungeePlayers(skungeePlayers)));
		return (times != null) ? times.toArray(new Number[times.size()]) : null;
	}

}
